//+------------------------------------------------------------------+
//|                                                    GarchTest_html.mq5 |
//|                                                           denkir |
//|                                                 denkir@gmail.com |
//+------------------------------------------------------------------+
#property copyright "denkir"
#property link      "denkir@gmail.com"
#property version   "1.00"
//#property script_show_inputs
// included files
//#include <Complex_class.mqh>    <FFT_class.mqh>
#include <FFT_class.mqh>
#include <Trade\SymbolInfo.mqh>
#import "shell32.dll"
int ShellExecuteW(int hwnd,string lpOperation,string lpFile,string lpParameters,
                  string lpDirectory,int nShowCmd);
#import
// definitions
#define ITMAX 100 //maximum allowed number of iterations
#define EPS 3.0e-7 //relative accuracy
#define FPMIN 1.0e-30 //number near the smallest representable double number

                      //functions declarations
void gser(double &gamser,double a,double x,double &gln);
void gcf(double &gammcf,double a,double x,double &gln);
void nrerror(string error_text);
double gammp(double a,double x);
double gammln(double xx);

void autocorr(double &ACF[],double &res[],int nLags);//(1- )
void autocorr(double &ACF[],double &bounds[],int &lags[],double &res[],int nLags);//(2- )
void lbqtest(bool &H[],double &rets[]);
void cumsum(double &sum[],double &x[]);
//void lbqtestInfo(bool &h1[],bool &h2[],double &ACF[],double &bounds[],int &lags[]);
void lbqtestInfo(bool &h1[],bool &h2[],double &rets[],double &retsq[],int &lags[]);
bool any(bool &h[]);
void filesave(double &ACF1[],double &bounds1[]);

//===
int hRI,//ReturnsIndicator handle
start,  //start time
finish; //finish time
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   start=GetTickCount(); //  ,   
   int N=SeriesInfoInteger(Symbol(),0,SERIES_BARS_COUNT);
   MqlRates rates[]; ArraySetAsSeries(rates,true);
   double nClose1[];
   ArrayResize(nClose1,N);
   int copied=CopyRates(Symbol(),0,0,N,rates);
   if(copied>0)
      Print(" : "+copied);
   else
      Print("      ",Symbol());
   for(int i=0;i<N;i++)
     {
      nClose1[i]=rates[i].close;
     }
   ArraySetAsSeries(nClose1,true);
// ACF
   double rets1[],//rets1 -    N,
   rets[],        //rets - -  N-1
   retsq[];       //rets - -   N-1
   ArrayResize(rets1,N);ArrayResize(rets,N-1);ArrayResize(retsq,N-1);
   hRI=iCustom(NULL,0,"ReturnsIndicator");
   if(CopyBuffer(hRI,0,0,N,rets1)<1)
     {
      Print("    !");
      return;
     }
   if(ArrayCopy(rets,rets1,0,1,N-1)<1)
     {
      Print("    !");
      return;
     }
   bool h1[3],h2[3]; //  
   double m = mean(rets);
   for(int t=0;t<ArraySize(rets);t++)
     {
      rets[t]=rets[t]-m;
      retsq[t]=pow(rets[t],2);
     }
   lbqtest(h1,rets); //Q-   
   lbqtest(h2,retsq);//Q-    
   int lags[];
   string path=TerminalInfoString(TERMINAL_DATA_PATH)+"\\MQL5\\Files\\Autocorrelation.htm";
   lbqtestInfo(h1,h2,rets,retsq,lags); //   
   ShellExecuteW(NULL,"open",path,NULL,NULL,1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void lbqtest(bool &H[],double &rets[])
/* ,  Q- --
   H -    ,   
        ;
   rets -     ;
*/
  {
   double lags[3]={10.0,15.0,20.0};       //  
   int maxLags=20;                        //  
   double ACF[]; ArrayResize(ACF,21);     //  
   double acf[]; ArrayResize(acf,20);     //  
   autocorr(ACF,rets,maxLags);            //  
   for(int i=0;i<20;i++) acf[i]=ACF[i+1]; //   - , 
                                          //-                            
   double alpha[3]={0.05,0.05,0.05};      //   

/*  Q-   
   :            
                  L
                |----|
                 \
       Q = T(T+2) || (rho(k)^2/(T-k)), 
                 /  
                |----| 
                  k=1
   T -  , L -  , rho(k) -    k- .
*/

   double idx[]; ArrayResize(idx,maxLags);     //  
   int len=ArraySize(rets);                    //  
   int arrLags[];ArrayResize(arrLags,maxLags); //  
   double stat[]; ArrayResize(stat,maxLags);   // Q-
   double sum[]; ArrayResize(sum,maxLags);     //  
   double iACF[];ArrayResize(iACF,maxLags);    //  
   for(int i=0;i<maxLags;i++)
     {                                         //:
      arrLags[i]=i+1;                          //       
      idx[i]=len-arrLags[i];                   //        
      iACF[i]=pow(acf[i],2)/idx[i];            //       
     }
   cumsum(sum,iACF);                           //    
                                               //                         
   for(int i=0;i<maxLags;i++)
      stat[i]=sum[i]*len*(len+2);              //  Q-: stat[i]=len*(len+2)*sum[i]; ???
   double stat1[];                             //  Q-
   ArrayResize(stat1,ArraySize(lags));
   for(int i=0;i<ArraySize(lags);i++)
      stat1[i]=stat[lags[i]-1];                // -   

   double pValue[ArraySize(lags)];             // p-
   for(int i=0;i<ArraySize(lags);i++)
     {
      pValue[i]=1-gammp(lags[i]/2,stat1[i]/2); // p-
      H[i]=alpha[i]>=pValue[i];                //  
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void lagmatrix(double &Y[],double &X[],int lag)
//    
  {
   int len=ArraySize(X);
   ArrayResize(Y,len);
   ArrayInitialize(Y,MathArcsin(2.0)); // NaN
   if(lag>=0)
      for(int t=0;t<len-lag;t++)
         Y[t+lag]=X[t];
   else
   for(int t=0;t<len+lag;t++)
             Y[t]=X[t-lag];
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void cumsum(double &sum[],double &x[])
//                 
  {
   sum[0]=x[0];
   for(int i=1;i<ArraySize(x);i++)
      sum[i]=x[i]+sum[i-1];
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void autocorr(double &ACF[],double &res[],int nLags) //1- 
/*     ()      
   ACF -      ;
   res -     ;
   nLags -   ,    .
*/
  {
   Complex Data1[],Data21[], //   
   Data2[],Data22[],         //   
   cData[];                  //              
   double rA[][2];           //    

   int nFFT=pow(2,nextpow2(ArraySize(res))+1);      //  
   ArrayResize(rA,nFFT);ArrayResize(Data1,nFFT);    //  
   ArrayResize(Data2,nFFT);ArrayResize(Data21,nFFT);
   ArrayResize(Data22,nFFT);ArrayResize(cData,nFFT);

   double rets1[];                   //    
   double m=mean(res);               //   res
   ArrayResize(rets1,nFFT);          //  
   for(int t=0;t<ArraySize(res);t++) //    
      //      
      rets1[t]=res[t]-m;
   setComplexArr(Data1,rets1); //       
   CFFT F,F1;                  //   CFFT
   F.setCFFT(Data1,Data2);     // -   F
   F.Forward(nFFT);            //   
   for(int i=0;i<nFFT;i++)
     {
      Data21[i].opEqual(F.Output[i]);//  Data21   F.Output;
      cData[i].conjugate(Data21[i]); //     Data21
      Data21[i].opMultEq(cData[i]);  //      
                                     //  ,     
     }
   F1.setCFFT(Data21,Data22);   // -   F1   
   F1.InverseT(nFFT);           //    
   getComplexArr(rA,F1.Output); //   double  
                                //      
   for(int i=0;i<nLags+1;i++)
     {
      ACF[i]=rA[i][0];          //    ACF  
                                // 
      ACF[i]=ACF[i]/rA[0][0];   //   
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void autocorr(double &ACF[],double &bounds[],int &lags[],double &res[],int nLags) //2- 
/*     ()      
   ACF -      ;
   bounds -      ;
   lags -  ; 
   res -     ;
   nLags -   ,    .
*/
  {
   Complex Data1[],Data21[], //   
   Data2[],Data22[],         //   
   cData[];                  //              
   double rA[][2];           //    

   int nFFT=pow(2,nextpow2(ArraySize(res))+1);      //  
   ArrayResize(rA,nFFT);ArrayResize(Data1,nFFT);    //    nFFT
   ArrayResize(Data2,nFFT);ArrayResize(Data21,nFFT);
   ArrayResize(Data22,nFFT);ArrayResize(cData,nFFT);

   double rets1[];                   //    
   double m=mean(res);               //   res
   ArrayResize(rets1,nFFT);          //  
   for(int t=0;t<ArraySize(res);t++) //    
      //      
      rets1[t]=res[t]-m;
   setComplexArr(Data1,rets1); //       
   CFFT F,F1;                  //   CFFT
   F.setCFFT(Data1,Data2);     // -   F
   F.Forward(nFFT);            //   
   for(int i=0;i<nFFT;i++)
     {
      Data21[i].opEqual(F.Output[i]);//  Data21   F.Output;
      cData[i].conjugate(Data21[i]); //     Data21
      Data21[i].opMultEq(cData[i]);  //      
                                     //  ,     
     }
   F1.setCFFT(Data21,Data22);   // -   F1   
   F1.InverseT(nFFT);           //    
   getComplexArr(rA,F1.Output); //   double  
                                //      
   for(int i=0;i<nLags+1;i++)
     {
      ACF[i]=rA[i][0];          //    ACF  
                                // 
      ACF[i]=ACF[i]/rA[0][0];   //   
     }
//    
   double sigmaNMA;
   sigmaNMA=sqrt(1.0/ArraySize(res)); //   
   ArrayResize(bounds,2);
   double numSTD[2]={2,-2};           //     
   for(int i=0;i<2;i++)
      bounds[i]=sigmaNMA*numSTD[i];   //     
   ArrayResize(lags,nLags+1);
   for(int i=0;i<nLags+1;i++)
      lags[i]=i;                      // 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double mean(double &X[])
// 
  {
   int len=ArraySize(X);
   double sum=0;
   for(int g=0;g<len;g++)
      sum+=X[g];
   return(sum/len);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int nextpow2(int n)
//    p,  2^p >= n
  {
   double F=0;
   double E=0;
   log2(F,E,n);
   if(F==0.5)
      E-=1; //E=E-1; 
   if(!MathIsValidNumber(F))
      E=F;
   return(E);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void log2(double &F,double &E,int n)
//    2
  {
   E = ceil(log(n)/log(2));
   F = n/pow(2,E);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void gser(double &gamser,double a,double x,double &gln)
/* Returns the incomplete gamma function P(a; x) evaluated
 by its series representation as gamser. */
  {
   int n;
   double sum,del,ap;
   gln=gammln(a);
   if(x<=0.0)
     {
      if(x<0.0) nrerror("x less than 0 in routine gser");
      gamser=0.0;
      return;
     }
   else
     {
      ap=a;
      del=sum=1.0/a;
      for(n=1;n<=ITMAX;n++)
        {
         ++ap;
         del *= x/ap;
         sum += del;
         if(fabs(del)<fabs(sum)*EPS)
           {
            gamser=sum*exp(-x+a*log(x)-(gln));
            return;
           }
        }
      nrerror("a too large, ITMAX too small in routine gser");
      return;
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void gcf(double &gammcf,double a,double x,double &gln)
/* Returns the incomplete gamma function Q(a; x) evaluated by its continued 
fraction representation as gammcf. Also returns ln (a) as gln.
*/
  {
   int i;
   double an,b,c,d,del,h;
   gln=gammln(a);
   b=x+1.0-a; //Set up for evaluating continued fraction by modified Lentz's method (x5.2) with b0 = 0.
   c=1.0/FPMIN;
   d=1.0/b;
   h=d;
   for(i=1;i<=ITMAX;i++)
     { //Iterate to convergence.
      an = -i*(i-a);
      b += 2.0;
      d=an*d+b;
      if(fabs(d)<FPMIN) d=FPMIN;
      c=b+an/c;
      if(fabs(c)<FPMIN) c=FPMIN;
      d=1.0/d;
      del=d*c;
      h *= del;
      if(fabs(del-1.0)<EPS) break;
     }
   if(i>ITMAX)
      nrerror("a too large, ITMAX too small in gcf");
   gammcf=exp(-x+a*log(x)-gln)*h; //Put factors in front.
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void nrerror(string error_text)
// 
  {
   Print("Numerical Recipes run-time error...\n");
   Print("%s\n",error_text);
   Print("...now exiting to system...\n");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double gammp(double a,double x)
//Returns the incomplete gamma function P(a; x).
  {
   double gamser,gammcf,gln;
   if(x<0.0 || a<=0.0) nrerror("Invalid arguments in routine gammp");
   if(x<(a+1.0))
     { //Use the series representation.
      gser(gamser,a,x,gln);
      return gamser;
     }
   else
     { //Use the continued fraction representation
      gcf(gammcf,a,x,gln);
      return 1.0-gammcf; //and take its complement.
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double gammln(double xx)
//Returns the value ln[(xx)] for xx > 0.
  {
//Internal arithmetic will be done in double precision, a nicety that 
//you can omit if five-figure accuracy is good enough.
   double x,y,tmp,ser;
   static double cof[6]=
     {
      76.18009172947146,-86.50532032941677,
      24.01409824083091,-1.231739572450155,
      0.1208650973866179e-2,-0.5395239384953e-5
     };
   int j;
   y=x=xx;
   tmp=x+5.5;
   tmp-=(x+0.5)*log(tmp);
   ser=1.000000000190015;
   for(j=0;j<=5;j++) ser+=cof[j]/++y;
   return -tmp+log(2.5066282746310005*ser/x);
  }
//+------------------------------------------------------------------+
void lbqtestInfo(bool &h1[],bool &h2[],double &rets[],double &retsq[],int &lags[])
  {
   CSymbolInfo m_smbinf; //   CSymbolInfo
   m_smbinf.Refresh(); m_smbinf.RefreshRates(); // refresh symbol info
   ENUM_TIMEFRAMES period=_Period;
   string periodStr;
   periodStr=EnumToString(period);

   m_smbinf.Name(Symbol());// /   
   string title="Q-  ",msg,
   str1="  ",str2="  ",
   str11="  .",str21="   .",
   Str1,Str2,
   line="--------------------------------------------",
   blanc="            ";
   double ACF1[],bounds1[],ACF2[],bounds2[];
   ArrayResize(ACF1,21);ArrayResize(ACF2,21);
   int maxLags=20;
   autocorr(ACF1,bounds1,lags,rets,maxLags);
   autocorr(ACF2,bounds2,lags,retsq,maxLags);

   if(h1[2]) Str1=str1;//    
   else Str1=str2;       //    
   if(h2[2]) Str2=str1;//     
   else Str2=str2;       //     

   msg=""+m_smbinf.Name()+", "+periodStr+"\n"
       +line+"\n"+Str1+"\n"+str11+"\n"+Str2+"\n"+str21
       +"\n"+line
       +"\n"+"# "+blanc+""+blanc+""
       ; //

   double acf1[]; ArrayResize(acf1,20);
   double acf2[]; ArrayResize(acf2,20);
   ArrayCopy(acf1,ACF1,0,1,ArraySize(ACF1));
   ArrayCopy(acf2,ACF2,0,1,ArraySize(ACF2));
   filesave(acf1,bounds1);
   for(int i=9,k=0;i<21;i+=5,k++)
      msg=msg+"\n"+"     "+lags[i+1]+"   "+blanc+h1[k]+"   "+blanc+h2[k];

//  Q-  
   finish=GetTickCount()-start;  //   
   msg=msg+"\n"+line+"\n"+"   "+DoubleToString(finish,0)+" msec";
   MessageBox(msg,title,MB_OK|MB_ICONINFORMATION);
  }
//+------------------------------------------------------------------+
bool any(bool &h[])
//,    "true"   
  {
   bool B=false;
   for(int i=0;i<ArraySize(h);i++)
     {
      if(h[i])
        {
         B=true;
         break;
        }
      else
         continue;
     }
   return B;
  }
//-----------------------------------------------------------------------------------
// Save file
//-----------------------------------------------------------------------------------
void filesave(double &ACF1[],double &bounds1[])
  {
   int fhandle;
   CSymbolInfo m_smbinf; //   CSymbolInfo
   m_smbinf.Refresh(); m_smbinf.RefreshRates(); // refresh symbol info
   ENUM_TIMEFRAMES period=_Period;
   string title,periodStr;
   periodStr=EnumToString(period);
   m_smbinf.Name(Symbol());// /   
   title="var title=\""+m_smbinf.Name()+", "+periodStr+"\"";
   ResetLastError();
   fhandle=FileOpen("data.txt",FILE_WRITE|FILE_TXT|FILE_ANSI);
   if(fhandle<0){Print("File open failed, error ",GetLastError());return;}
   string str1="var ACF=[",str2="var uBound=[",str3="var lBound=[";
   for(int i=1;i<20;i++)
     {
      if(fabs(ACF1[i])>bounds1[0]) //todo
         str1+="{y: "+DoubleToString(NormalizeDouble(ACF1[i],7),5)+",color: '#6600CC'},";
      else
         str1+=DoubleToString(NormalizeDouble(ACF1[i],7),5)+",";
      str2+=DoubleToString(NormalizeDouble(bounds1[0],7),5)+",";
      str3+=DoubleToString(NormalizeDouble(bounds1[1],7),5)+",";
     }

   str1+=DoubleToString(NormalizeDouble(ACF1[19],7),5)+"];";
   str2+=DoubleToString(NormalizeDouble(bounds1[0],7),5)+"];";
   str3+=DoubleToString(NormalizeDouble(bounds1[1],7),5)+"];";
   FileWriteString(fhandle,title+"\n");
   FileWriteString(fhandle,str1+"\n");
   FileWriteString(fhandle,str2+"\n");
   FileWriteString(fhandle,str3+"\n");
   FileClose(fhandle);
  }
//+------------------------------------------------------------------+
